/* Copyright (c) 1988 by Carrick Sean Casey. All rights reserved. */
/* For copying and distribution information, see the file "copyright.h." */

/* connect to a port */

#include "../copyright.h"
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include "select.h"
#include "ipcf.h"
#include "externs.h"

connecttoport(host_name, port_number)
char *host_name;
int port_number;
{
	int s;
	struct sockaddr_in saddr;
	struct hostent *hp;

	/* get the client host inet address */
	if ((hp = gethostbyname(host_name)) < 0) {
		fail = "can't lookup server INET address";
		return(-1);
	}

	/* insert hostname into address */
	bzero((char *) &saddr, sizeof(saddr));
	bcopy(hp->h_addr, (char *) &saddr.sin_addr, hp->h_length);

	/* fill in socket domain and port number */
	saddr.sin_family = hp->h_addrtype;
	saddr.sin_port = htons(port_number);

	/* create a socket */
	if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		fail = "couldn't create socket";
		return(-1);
	}

	/* connect it to the server inet address */
	if (connect(s, (struct sockaddr *) &saddr, sizeof(saddr)) < 0) {
		fail = "couldn't connect to server (not running?)";
		return(-1);
	}

	port_fd = s;
	return(0);
}
